unit uPlayList;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, OleCtrls, voicerlibLib_TLB, ShellApi;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    btnIniciaVoicerLib: TButton;
    btnFinalizaVoicerLib: TButton;
    grpReproduzir: TGroupBox;
    cmdFalaData: TButton;
    cmdFalaNumero: TButton;
    txtValor: TEdit;
    cmdFalaDinheiro: TButton;
    cmdFalaCardinal: TButton;
    cmdFalaHora: TButton;
    Label23: TLabel;
    txtStockSigPath: TEdit;
    GroupBox1: TGroupBox;
    memStatus: TMemo;
    Label1: TLabel;
    txtPorta: TEdit;
    btnAtender: TButton;
    btnDesligar: TButton;
    btnFalaArquivos: TButton;
    GroupBox2: TGroupBox;
    Label2: TLabel;
    txtValorMonetario: TEdit;
    LabelData: TLabel;
    txtData: TEdit;
    Label3: TLabel;
    txtCardinal: TEdit;
    Label4: TLabel;
    txtHora: TEdit;
    Label5: TLabel;
    txtNumero: TEdit;
    LabelArquivo: TLabel;
    txtArquivo: TEdit;
    btnReproduzir: TButton;
    raddm: TRadioButton;
    radmd: TRadioButton;
    radmdy: TRadioButton;
    raddmy: TRadioButton;
    Label6: TLabel;
    btnLeiaMe: TButton;
    Image1: TImage;
    vlib4: Tvoicerlib;
    btnLimpaLog: TButton;
    procedure btnLimpaLogClick(Sender: TObject);
    procedure cmdFalaDinheiroClick(Sender: TObject);
    procedure cmdFalaDataClick(Sender: TObject);
    procedure cmdFalaCardinalClick(Sender: TObject);
    procedure cmdFalaHoraClick(Sender: TObject);
    procedure cmdFalaNumeroClick(Sender: TObject);
    procedure MostraStatus(nPorta: Integer; sStatus: String);
    procedure vlib4RingDetected(ASender: TObject; Port: Smallint);
    procedure btnIniciaVoicerLibClick(Sender: TObject);
    procedure btnFinalizaVoicerLibClick(Sender: TObject);
    procedure btnAtenderClick(Sender: TObject);
    procedure btnDesligarClick(Sender: TObject);
    procedure btnFalaArquivosClick(Sender: TObject);
    procedure btnReproduzirClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure vlib4DigitDetected(ASender: TObject; Port, Digit: Smallint);
    procedure btnLeiaMeClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  sReturn    : array [0..255] of Char;
implementation

{$R *.dfm}

procedure TForm1.MostraStatus(nPorta: Integer; sStatus: String);
var
  ho,mi,se,mil:word;
begin
  DecodeTime(Now, ho, mi, se, mil);

  memStatus.Lines.Add(IntToStr(nPorta) + '> '+ IntToStr(ho) + ':' + IntToStr(mi) + ':' +
                      IntToStr(se) + ':' + IntToStr(mil) + ' -> ' + sStatus);

  if memStatus.Lines.Count > 10000 then
    memStatus.Lines.Delete(0);

  with memStatus do
  begin
    selstart := gettextlen;
    perform(em_scrollcaret, 0, 0);
  end;
end;

procedure TForm1.btnLimpaLogClick(Sender: TObject);
begin
  memStatus.Clear;
end;

procedure TForm1.cmdFalaDinheiroClick(Sender: TObject);
var
  nRet: Integer;
begin
  //Verifica se o driver esta habilitado
  if (vLib4.DriverEnabled)then
  begin
    if txtValor.Text <> '' then
    begin
      //Reproduz valores monetrios por extenso
      nRet := vLib4.PlayCurrency (StrToint(txtPorta.Text), txtValor.Text, '#', 0);
      if nRet <> DG_EXIT_SUCCESS then
        MostraStatus(StrToint(txtPorta.Text), 'Erro ao executar "PlayCurrency"');
    end
    else
      MostraStatus(StrToint(txtPorta.Text), 'ATENO: Voc no informou nada a ser reproduzido');
  end
  else
    MostraStatus(0, 'ATENO: O Driver No Est Inicializado');
end;

procedure TForm1.cmdFalaDataClick(Sender: TObject);
var
  nRet: Integer;
begin

  //Verifica se o driver esta habilitado
  if vLib4.DriverEnabled then
  begin
    if txtValor.Text <> '' then
    begin
      //Reproduz data por extenso
      nRet := vLib4.PlayDate(StrToint(txtPorta.Text), txtValor.Text, 'd/m/y', '#', 0);
      if nRet <> DG_EXIT_SUCCESS then
        MostraStatus(StrToint(txtPorta.Text), 'Erro ao executar "PlayDate"');
    end
    else
      MostraStatus(StrToint(txtPorta.Text), 'ATENO: Voc no informou nada a ser reproduzido');
  end
  else
    MostraStatus(0, 'ATENO: O Driver No Est Inicializado');
end;

procedure TForm1.cmdFalaCardinalClick(Sender: TObject);
var
  nRet: Integer;
begin

  //Verifica se o driver esta habilitado
  if vLib4.DriverEnabled then
  begin
    if txtValor.Text <> '' then
    begin
      //Reproduz numerais e cardinais inteiros ou fracionarios por extenso
      nRet := vLib4.PlayCardinal(StrToint(txtPorta.Text), txtValor.Text, '#', 500);
      if nRet <> DG_EXIT_SUCCESS then
        MostraStatus(StrToint(txtPorta.Text), 'Erro ao executar "PlayCardinal"');
    end
    else
      MostraStatus(StrToint(txtPorta.Text), 'ATENO: Voc no informou nada a ser reproduzido');
  end
  else
    MostraStatus(0, 'ATENO: O Driver No Est Inicializado');
end;

procedure TForm1.cmdFalaHoraClick(Sender: TObject);
var
  nRet: Integer;
begin

  //Verifica se o driver esta habilitado
  if vLib4.DriverEnabled then
  begin
    if txtValor.Text <> '' then
    begin
      //Reproduz hora por extenso
      nRet := vLib4.PlayTime(StrToint(txtPorta.Text), txtValor.Text, '#', 0);
      if nRet <> DG_EXIT_SUCCESS then
        MostraStatus(StrToint(txtPorta.Text), 'Erro ao executar "PlayTime"');
    end
    else
      MostraStatus(StrToint(txtPorta.Text), 'ATENO: Voc no informou nada a ser reproduzido');
  end
  else
    MostraStatus(0, 'ATENO: O Driver No Est Inicializado');
end;

procedure TForm1.cmdFalaNumeroClick(Sender: TObject);
var
  nRet: Integer;
begin

  //Verifica se o driver esta habilitado
  if vLib4.DriverEnabled then
  begin
    if txtValor.Text <> '' then
    begin
      //Reproduz numeros digito a digito
      nRet := vLib4.PlayNumber(StrToint(txtPorta.Text), txtValor.Text, '#', 500);
      if nRet <> DG_EXIT_SUCCESS then
        MostraStatus(StrToint(txtPorta.Text), 'Erro ao executar "PlayNumber"');
    end
    else
      MostraStatus(StrToint(txtPorta.Text), 'ATENO: Voc no informou nada a ser reproduzido');
  end
  else
    MostraStatus(0, 'ATENO: O Driver No Est Inicializado');
end;

procedure TForm1.vlib4RingDetected(ASender: TObject; Port: Smallint);
begin
  MostraStatus(Port,'Ring....');
end;

procedure TForm1.btnIniciaVoicerLibClick(Sender: TObject);
var
  nRet : Integer;
begin
  //Inicializa a voicerlib
  nRet := vlib4.StartVoicerLib;
  //Trata o retorno da inicializacao
  vlib4.ReturnCodeToString(nRet,Cardinal(@sReturn));

  if nRet <> DG_EXIT_SUCCESS then
  begin
    MostraStatus(StrToint(txtPorta.Text),'Erro ao iniciar a VoicerLib. Erro -> ' + sReturn);
    Exit;
  end
  else
  begin
    MostraStatus(StrToint(txtPorta.Text),'Voicerlib iniciada com sucesso');
    btnIniciaVoicerLib.Enabled := False;
    btnFinalizaVoicerLib.Enabled  := True;
    //Configura o caminho do stocksigs ou seja, onde os arquivos do tipo 'wav' esto armazenados por padro
    vlib4.StockSigPath := txtStockSigPath.Text;
  end;
end;

procedure TForm1.btnFinalizaVoicerLibClick(Sender: TObject);
var
  nRet : Integer;
begin

  //Finaliza a voicerlib
  nRet := vlib4.ShutdownVoicerLib;
  if nRet <> DG_EXIT_SUCCESS then
  begin
    MostraStatus(StrToint(txtPorta.Text),'Erro ao finalizar a Voicerlib');
    Exit;
  end
  else
  begin
    MostraStatus(StrToint(txtPorta.Text),'Voicerlib finalizada com sucesso');
    btnFinalizaVoicerLib.Enabled := False;
    btnIniciaVoicerLib.Enabled := True;
  end;
end;

procedure TForm1.btnAtenderClick(Sender: TObject);
var
  nRet : Integer;
begin

  //Atende a porta
  nRet := vlib4.PickUp(StrToint(txtPorta.Text),100);
  if nRet <> DG_EXIT_SUCCESS then
    MostraStatus(StrToint(txtPorta.Text),'Erro ao atender')
  else
    MostraStatus(StrToint(txtPorta.Text),'Atendeu com sucesso');

end;

procedure TForm1.btnDesligarClick(Sender: TObject);
var
  nRet : Integer;
begin

  //Desliga a porta
  nRet := vlib4.HangUp(StrToint(txtPorta.Text));
  if nRet <> DG_EXIT_SUCCESS then
    MostraStatus(StrToint(txtPorta.Text),'Erro ao desligar')
  else
    MostraStatus(StrToint(txtPorta.Text),'Desligou com sucesso');
end;

procedure TForm1.btnFalaArquivosClick(Sender: TObject);
begin

  //Limpa os itens da lista
  vlib4.PlayListClear(StrToInt(txtPorta.Text));
  //Adiciona arquivo no PlayList
  vlib4.PlayListAdd(StrToInt(txtPorta.Text),ptFile, ExtractFilePath(Application.ExeName) + '1.wav', '', 0);
  vlib4.PlayListAdd(StrToInt(txtPorta.Text),ptFile, ExtractFilePath(Application.ExeName) + '2.wav', '', 0);
  vlib4.PlayListAdd(StrToInt(txtPorta.Text),ptFile, ExtractFilePath(Application.ExeName) + '3.wav', '', 0);
  vlib4.PlayListAdd(StrToInt(txtPorta.Text),ptFile, ExtractFilePath(Application.ExeName) + '4.wav', '', 0);
  vlib4.PlayListAdd(StrToInt(txtPorta.Text),ptFile, ExtractFilePath(Application.ExeName) + '5.wav', '', 0);
  vlib4.PlayList(StrToInt(txtPorta.Text),'');
   
end;

procedure TForm1.btnReproduzirClick(Sender: TObject);
begin

  if (txtValorMonetario.Text = '') or (txtData.Text = '') or (txtCardinal.Text = '') or
     (txtHora.Text = '') or (txtNumero.Text = '') or (txtArquivo.Text = '') then
    ShowMessage(' preciso preencher todos os campos...');

  //Limpa os itens da lista
  vlib4.PlayListClear(StrToInt(txtPorta.Text));
  //Monetario
  vlib4.PlayListAdd(StrToInt(txtPorta.Text),ptCurrency,txtValorMonetario.Text, '', 0);

  //Data
  if raddmy.Checked then
    vlib4.PlayListAdd(StrToInt(txtPorta.Text),ptDate,txtData.Text, 'd/m/y', 0)
  else
  begin
    if raddm.Checked then
      vlib4.PlayListAdd(StrToInt(txtPorta.Text),ptDate,txtData.Text, 'd/m', 0)
    else
    begin
      if radmd.Checked then
        vlib4.PlayListAdd(StrToInt(txtPorta.Text),ptDate,txtData.Text, 'm/d', 0)
      else
      begin
        if radmdy.Checked then
          vlib4.PlayListAdd(StrToInt(txtPorta.Text),ptDate,txtData.Text, 'm/d/y', 0)
      end;
    end;
  end;

  //Cardinal
  vlib4.PlayListAdd(StrToInt(txtPorta.Text),ptCardinal,txtCardinal.Text, '', 0);
  //Hora
  vlib4.PlayListAdd(StrToInt(txtPorta.Text),ptTime,txtHora.Text, '', 0);
  //Numero
  vlib4.PlayListAdd(StrToInt(txtPorta.Text),ptNumber,txtNumero.Text, '', 0);
  //Arquivo
  vlib4.PlayListAdd(StrToInt(txtPorta.Text),ptFile, txtArquivo.Text, '', 0);
  vlib4.PlayList(StrToInt(txtPorta.Text),'');
  
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  nRet : Integer;
  cVersao : array[0..255] of Char;
begin
  txtArquivo.Text := ExtractFilePath(Application.ExeName) + 'OBRIGADA.wav';
  
  //Verifica a versao da dll e ocx da voicerlib
  nRet := vlib4.GetLibVersion(Cardinal(@cVersao),0);
  if nRet = DG_EXIT_SUCCESS then
    MostraStatus(0,'Verso DLL -> ' + cVersao)
  else
    MostraStatus(0,'Verso DLL -> Falha');

  nRet := vlib4.GetLibVersion(Cardinal(@cVersao),1);
  if nRet = DG_EXIT_SUCCESS then
    MostraStatus(0,'Verso OCX -> ' + cVersao)
  else
    MostraStatus(0,'Verso OCX -> Falha');

end;

procedure TForm1.vlib4DigitDetected(ASender: TObject; Port,
  Digit: Smallint);
begin
  MostraStatus(Port,IntToStr(Digit)); 
end;



procedure TForm1.btnLeiaMeClick(Sender: TObject);
var
  L:String;
begin
  L:= ExtractFilePath(Application.ExeName) + 'Leiame.txt';
  ShellExecute(0 ,nil,PChar(L), nil, nil,SW_NORMAL);

end;

end.
